#ifndef SDLINPUTS_H
#define SDLINPUTS_H

event_t KeyDown;
event_t MButtonDown;
event_t MButtonUp;
event_t MButtonPressed;
event_t MMotion;

#define CREATE_QUEUE( name, itemtype ) \
 static itemtype* name = 0L; \
 static int name##_size = 0;\
 static int name##_pos = 0; \
 \
 /* Queue manipulation function */ \
 static itemtype* add_##name( itemtype* item ) { \
   ALLOCATE_QUEUE_MEMORY( name, itemtype ); \
   name[ name##_pos ] = *item; \
   return &name[ name##_pos++ ]; \
 }

#define ALLOCATE_QUEUE_MEMORY( queue, itemtype ) \
  if ( queue##_pos == queue##_size ) { \
    queue = (itemtype*)malloc( ( queue##_size += 128 ) * sizeof( itemtype )); \
    if ( !queue ) { \
      fprintf( stderr, "Module SDL_inputs: Not enough memory\n" ); \
      exit( 1 ); \
    } \
  }

module DebugInputs, SDLInputs;
void sdl_input_init (scheduler_t sdl_scheduler);

#endif
